unit usetlanguage;

{$mode delphi}

interface

uses
  Classes, SysUtils,
  LResources,
  LCLTranslator;

(*

Esta unidad permite realizar el cambio de idioma buscando en la misma carpeta
con el nombre del ejecutable un archivo con extensión .mo

Incluir esta unidade en el archivo del proyecto y ejecutar SetLanguage
al inicio del procedimiento principal.

*)

procedure SetLanguage;
procedure ChangeLanguage( new_LangId: string );

// retorna el identificador de dos caracteres 'es', 'en'
function idioma: string;

implementation

var
   langID: string;

function archiLangId: string;
begin
  result:= ExtractFileDir(ParamStr(0))+DirectorySeparator+'language_id.txt';
end;

procedure ChangeLanguage( new_LangId: string );
var
  archi: string;
  f: textfile;
begin
  archi:= archiLangId;
  assignfile( f, archi );
  rewrite( f );
  writeln( f, new_langId );
  closefile( f );
  SetLanguage;
end;

procedure SetLanguage;
var
  LanguageFileName: string;
  f: textfile;
  camino: string;
  archi: string;
  i: integer;

begin
  filemode:= 0;
  langID:= '';

  archi:= archiLangId;
  if fileexists( archi ) then
  begin
    assignfile( f, archi );
    reset( f );
    readln( f, langID );
    closefile( f );
    langID:= trim( langID );
  end;

  LanguageFileName := ParamStr(0);

  camino:= ExtractFileDir( LanguageFileName );
  archi:= ExtractFileName( LanguageFileName );

  // si en nombre de archivo hay un "_" borro lo que esté de ahí en adelante
  i:= pos( '_', archi );
  while  i > 0 do
  begin
    delete( archi, i, length( archi ) - i +1 );
    i:= pos( '_', archi );
  end;

//  LanguageFileName:= camino+DirectorySeparator+'languages'+DirectorySeparator+archi;
  LanguageFileName:= camino+DirectorySeparator+archi;

  if langID <> '' then
    LanguageFileName := ChangeFileExt(LanguageFileName, '.'+langID+'.po')
  else
    LanguageFileName := ChangeFileExt(LanguageFileName, '.po');

  if FileExists(LanguageFileName) then
  begin
    if LRSTranslator <> nil then
      LRSTranslator.Free;
    LRSTranslator := TPoTranslator.Create(LanguageFileName);
  end;
end;

function idioma: string;
begin
  result:= langID;
end;

end.

